<template>
    <v-chip
        size="x-small"
        :class="attr('class')"
        :hidden="!attr('class')"
        label
    >
        <div v-if="slots.title">
            <div>
                <slot name="title"></slot>
            </div>
        </div>
        <div v-else>
            <div>
                {{ translate(`statuses.labels.${props.status}`) }}
            </div>
        </div>
    </v-chip>
</template>

<script setup lang="ts">
import { defineProps, useSlots } from 'vue';
import { useI18n } from 'vue-i18n';
import { ActivityStatusEnum } from "@/enums/generalEnum";

const { t: translate } = useI18n();

const slots = useSlots();

const props = defineProps({
    status: {
        type: String,
        default: '',
        validator: (status: any) => [
            ActivityStatusEnum.ACTIVE,
            ActivityStatusEnum.INACTIVE,
            ActivityStatusEnum.CREATED,
            ActivityStatusEnum.QUEUED,
            ActivityStatusEnum.PENDING,
            ActivityStatusEnum.FAILED,
            ActivityStatusEnum.SYNCED,
        ].includes(status.toString())
    },
});

const attr = (property: any) => {
    let attributes = { class: '' };

    switch (props.status) { // all at once doesn't work
        case ActivityStatusEnum.ACTIVE:
            attributes = { class: '!bg-statuses-active-rgba !font-bold', }; break;
        case ActivityStatusEnum.INACTIVE:
            attributes = { class: '!bg-statuses-inactive-rgba !font-bold', }; break;
        case ActivityStatusEnum.CREATED:
            attributes = { class: '!bg-statuses-created-rgba !font-bold', }; break;
        case ActivityStatusEnum.QUEUED:
            attributes = { class: '!bg-statuses-queued-rgba !font-bold', }; break;
        case ActivityStatusEnum.PENDING:
            attributes = { class: '!bg-statuses-pending-rgba !font-bold', }; break;
        case ActivityStatusEnum.FAILED:
            attributes = { class: '!bg-statuses-failed-rgba !font-bold', }; break;
        case ActivityStatusEnum.SYNCED:
            attributes = { class: '!bg-statuses-synced-rgba !font-bold', }; break;
    }

    return attributes[property] ?? ''
}
</script>
